import 'package:flutter/services.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:native_convert/native_convert.dart';

void main() {
  const MethodChannel channel = MethodChannel('native_convert');

  TestWidgetsFlutterBinding.ensureInitialized();

  setUp(() {
    channel.setMockMethodCallHandler((MethodCall methodCall) async {
      return '42';
    });
  });

  tearDown(() {
    channel.setMockMethodCallHandler(null);
  });

  test('getPlatformVersion', () async {
    expect(await NativeConvert.platformVersion, '42');
  });
}
